﻿topicarray["c5d1340f3978d513cbd4d7e2b28cbe82"] = {"Html":"\u003c?xml version=\"1.0\" encoding=\"utf-16\"?\u003e\u003chtml xmlns:msxsl=\"urn:schemas-microsoft-com:xslt\"\u003e\u003cdiv class=\"main_body\"\u003e\u003cbr /\u003e\u003cdiv class=\"content_body\"\u003e\u003cdiv class=\"body_headline\" style=\"display:none;\"\u003eStatistical Evaluation of Cause of Error\u003c/div\u003e\u003cdiv class=\"expandable-container\" data-type=\"principle\"\u003e\u003cdiv class=\"h4 block-title header-object\" data-expandable=\"minus\"\u003e\u003cspan class=\"data-expandable\"\u003eObjectives\u003cspan class=\"index-entry hidden\"\u003e\u003cspan class=\"index-entry-item\"\u003eCause of error\u003c/span\u003e\u003c/span\u003e\u003cspan class=\"index-entry hidden\"\u003e\u003cspan class=\"index-entry-item\"\u003eCallback Function\u003c/span\u003e\u003c/span\u003e\u003cspan class=\"index-entry hidden\"\u003e\u003cspan class=\"index-entry-item\"\u003eDiagnostics Entry Operand\u003c/span\u003e\u003c/span\u003e\u003cspan class=\"index-entry hidden\"\u003e\u003cspan class=\"index-entry-item\"\u003eFunctions\u003c/span\u003e\u003c/span\u003e\u003cspan class=\"index-entry hidden\"\u003e\u003cspan class=\"index-entry-item\"\u003eAlarms\u003c/span\u003e\u003c/span\u003e\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"expandable-content\" style=\"display: block;\"\u003e\u003cdiv class=\"p p-default floating-text\"\u003e\u003cspan\u003eIf an ALARM_S message that can be subjected to a criteria analysis appears, the results of the criteria analysis are saved in the message (associated process value blocks 7,8,9,10). This information includes the operand triggering the message and the diagnostics entry operand (refer to \"Criteria Analysis\").\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p p-default floating-text\"\u003e\u003cspan\u003eIf you want to use this information, for example, to make the results of the criteria analysis available to a higher-level control system and to evaluate them on that system from a statistical point of view, you must write a suitable function for evaluating this information. You will find further information about writing private functions in the Online Help for the \"Global Script\" editor.\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p p-default floating-text\"\u003e\u003cspan\u003eUsing a callback function, this function is called every time an ALARM_S message that can be subjected to a criteria analysis becomes active, is acknowledged and becomes inactive at Runtime.\u003c/span\u003e\u003c/div\u003e\u003c/div\u003e\u003c/div\u003e\u003cdiv class=\"expandable-container\" data-type=\"principle\"\u003e\u003cdiv class=\"h4 block-title header-object\" data-expandable=\"minus\"\u003e\u003cspan class=\"data-expandable\"\u003eFunction for Evaluating Criteria Analysis Results\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"expandable-content\" style=\"display: block;\"\u003e\u003cdiv class=\"p p-default floating-text\"\u003e\u003cspan\u003eThis function reads out the first blocked operand of an ALARM_S message that can be subjected to a criteria analysis, including its symbol and comment.\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p p-default floating-text\"\u003e\u003cspan\u003eYou will find more information on the structures used \"MSG_RTDATA_TEXTVAL256_STRUCT\" and \"MSG_COMMENT_STRUCT\" in the WinCC-ODK description.\u003c/span\u003e\u003c/div\u003e\u003c/div\u003e\u003c/div\u003e\u003cdiv class=\"expandable-container\" data-type=\"quintessence\"\u003e\u003cdiv class=\"h4 block-title header-object\" data-expandable=\"minus\"\u003e\u003cspan class=\"data-expandable\"\u003eProceed as follows\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"expandable-content\" style=\"display: block;\"\u003e\u003col class=\"floating-text\"\u003e\u003cli\u003e\u003cdiv class=\"p default floating-text\"\u003e\u003cspan\u003eOpen the \"Global Script\" editor in WinCC.\u003c/span\u003e\u003c/div\u003e\u003c/li\u003e\u003cli\u003e\u003cdiv class=\"p default floating-text\"\u003e\u003cspan\u003eIn the \"Function Drop-Down Box\" right-click the \"Project Functions\" entry.\u003c/span\u003e\u003c/div\u003e\u003c/li\u003e\u003cli\u003e\u003cdiv class=\"p default floating-text\"\u003e\u003cspan\u003eSelect the \"New\" → \"Function\" entry from the shortcut menu.\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p default floating-text\"\u003e\u003cspan\u003eThe editing window opens.\u003c/span\u003e\u003c/div\u003e\u003c/li\u003e\u003cli\u003e\u003cdiv class=\"p default floating-text\"\u003e\u003cspan\u003eConfigure the following function with any name. In the following example we will call it \"MyKritCallback\":\u003c/span\u003e\u003c/div\u003e\u003c/li\u003e\u003c/ol\u003e\u003c/div\u003e\u003c/div\u003e\u003cdiv class=\"expandable-container\" data-type=\"principle\"\u003e\u003cdiv class=\"h4 block-title header-object\" data-expandable=\"minus\"\u003e\u003cspan class=\"data-expandable\"\u003eExample program\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"expandable-content\" style=\"display: block;\"\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e#include \"apdefap.h\"\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e// ab ProAgent Version 5.5: Kommentarzeichen vor der nächsten Zeile wegnehmen\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e//#define PROAGENT_V55\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003eBOOL MyKritCallback(long progIndex, DWORD dwNotify,\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003eMSG_RTDATA_TEXTVAL256_STRUCT* pRtData, MSG_COMMENT_STRUCT*\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003eMsgComment, LPVOID lpvUser)\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  {\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  BOOL result;\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  long signalLen;\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  char signal[C7_MAX_SIGNAL + 1] = \"\";\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  char symbol[C7_MAX_SYMBOL + 1] = \"\";\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  char zuliComment[C7OM_MAX_COMM_STR + 1] = \"\";\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  char operandListKey[] = \"@OP:\";\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  if (pRtData == NULL)\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    {\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    printf(\"MyKritCallback: return FALSE (pRtData = NULL)\\r\\n\");\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    return FALSE;\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    }\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  if (MsgComment == NULL)\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    {\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    printf(\"MyKritCallback: return FALSE (MsgComment = NULL)\\r\\n\");\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    return FALSE;\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    }\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  if (MsgComment-\u0026gt;szText == NULL)\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    {\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    printf(\"MyKritCallback: return FALSE (MsgComment-\u0026gt;szText = NULL)\\r\\n\");\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    return FALSE;\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    }\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e // Nur Meldungen mit den Status \"Gekommen\" untersuchen\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  if((pRtData-\u0026gt;dwMsgState \u0026amp; 0xffff) != MSG_STATE_COME)\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    {\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    return TRUE;\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    }\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  else\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    {\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    // MsgComment-\u0026gt;szText: z.B.\"SYMB_E   1.0 E1.0 @OP:E1.0|E1.1|@DEO:M1.0@FV:07@ERR:00050005\"\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e   \u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    char* pos = NULL; // steht auf Anfang von \"@OP:\"\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    char* posSignalStart = NULL; // Anfang des aktuellen AbsolutOperanden\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    char* posSignalEnd = NULL; // Ende des aktuellen Absolutoperanden + 1 (Zeiger steht auf \u0027|\u0027)\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    posSignalStart = MsgComment-\u0026gt;szText;\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  #ifdef PROAGENT_V55\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    // ab ProAgent Version 5.5: nach \"@OP:\" suchen und ueberspringen\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    pos = strstr(MsgComment-\u0026gt;szText, operandListKey);\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    if (pos == NULL)\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      {\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      printf(\"MyKritCallback: Identification \u0027%s\u0027 not found in MsgComment-\u0026gt;szText!\\r\\n\", operandListKey);\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      }\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    else\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      posSignalStart = pos + strlen(operandListKey);\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  #endif\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  // alle Operanden aus String extrahieren\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  // falls nur der erste Operand benötigt wird, dann einfach das \"while(\" durch\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  // ein \"if(\" ersetzen\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  while(pos // Schluesselwort \"@OP:\" gefunden\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  \u0026amp;\u0026amp; (*posSignalStart != \u0027@\u0027) // Ende von Operanden noch nicht erreicht\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  \u0026amp;\u0026amp; (posSignalEnd = strchr(posSignalStart, \u0027|\u0027)) // \u0027|\u0027 als Abschluss gefunden\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  )\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    {\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    // aktuellen Absolutoperanden in \u0027signal\u0027 extrahieren\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    signalLen = min(posSignalEnd - posSignalStart, sizeof(signal) - 1);\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    if (signalLen \u0026gt; 0 \u0026amp;\u0026amp; signalLen \u0026lt;= C7_MAX_SIGNAL)\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      { \u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      strncpy(signal, posSignalStart, signalLen);\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      signal[signalLen] = 0;\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      symbol[0] = 0;\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      zuliComment[0] = 0;\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      // Symbol und Kommentar holen\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      result = C7_GetZuliTextEx(C7_GET_TAB_PARA, progIndex,\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      signal, symbol, zuliComment, NULL);\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      if(!result)\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      {\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      // kein Symbol und Kommentar gefunden, macht aber nichts, dann\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      // wird das Symbol und der Kommentar automatisch mit dem\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      // Absolutoperanden belegt\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      }\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      // Signal immer ausgeben, auch wenn kein Symbol\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      // oder Kommentar gefunden\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      printf(\"MyKritCallback: Signal: \\\"%s\\\", Symbol: \\\"%s\\\", Kommentar: \\\"%s\\\"\\r\\n\",\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      signal, symbol, zuliComment\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      );\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      }\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      else\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      {\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      printf(\"MyKritCallback: to short or to long operand in operand list (posSignalStart=%s)\\r\\n\", posSignalStart);\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      }\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      // für naechsten Operanden vorbereiten\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e      posSignalStart = posSignalEnd + 1;\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e    }\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  }\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e   \u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e  return TRUE;\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text p-code\"\u003e\u003cspan\u003e}\u003c/span\u003e\u003c/div\u003e\u003c/div\u003e\u003c/div\u003e\u003cdiv class=\"expandable-container\" data-type=\"principle\"\u003e\u003cdiv class=\"h4 block-title header-object\" data-expandable=\"minus\"\u003e\u003cspan class=\"data-expandable\"\u003eActivate Callback Function\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"expandable-content\" style=\"display: block;\"\u003e\u003cdiv class=\"p p-default floating-text\"\u003e\u003cspan\u003eProcedure for activating the \"MyKritCallback\" function as the callback function upon every change of status of a diagnosable message:\u003c/span\u003e\u003c/div\u003e\u003c/div\u003e\u003c/div\u003e\u003cdiv class=\"expandable-container\" data-type=\"principle\"\u003e\u003cdiv class=\"h4 block-title header-object\" data-expandable=\"minus\"\u003e\u003cspan class=\"data-expandable\"\u003eProceed as follows\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"expandable-content\" style=\"display: block;\"\u003e\u003col class=\"floating-text\"\u003e\u003cli\u003e\u003cdiv class=\"p default floating-text\"\u003e\u003cspan\u003eIn the \"Global Script\" editor, open the function \"ProAgentInit.pas\" in the \"Actions\\GlobalActions\" function group.\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p default floating-text\"\u003e\u003cspan\u003eThis function contains the line:\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p default floating-text\"\u003e\u003cspan class=\"code\"\u003eC7DIAG_MSG_PROC pCallBack = NULL;\u003c/span\u003e\u003c/div\u003e\u003c/li\u003e\u003cli\u003e\u003cdiv class=\"p default floating-text\"\u003e\u003cspan\u003eChange the text to the following line or insert your own function name:\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p default floating-text\"\u003e\u003cspan class=\"code\"\u003eC7DIAG_MSG_PROC pCallBack = MyKritCallback;\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p default floating-text\"\u003e\u003cspan\u003eThe \"MyKritCallback\" function is now executed when a diagnosable message becomes active or its status changes.\u003c/span\u003e\u003c/div\u003e\u003c/li\u003e\u003c/ol\u003e\u003cdiv class=\"p p-default floating-text\"\u003e\u003cspan\u003e \u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"safetycontainer inserted-object\"\u003e\u003ctable width=\"100%\" class=\"note\"\u003e\u003ctr valign=\"top\"\u003e\u003ctd colspan=\"3\" class=\"hint-headerContent\"\u003e\u003cp\u003e\u003cdiv style=\"display:table;\"\u003e\u003cdiv style=\"display:table-cell;vertical-align:middle;\"\u003eNote\u003c/div\u003e\u003c/div\u003e\u003c/p\u003e\u003c/td\u003e\u003c/tr\u003e\u003ctr class=\"hint-content\"\u003e\u003ctd class=\"emptyIcon\" /\u003e\u003ctd class=\"emptyIcon\" /\u003e\u003ctd class=\"hint-content-text\"\u003e\u003cdiv\u003e\u003cdiv class=\"p p-default floating-text\"\u003e\u003cspan\u003eWhen you regenerate you project and operate the button \"Overwrite ProAgent Screens and C Script\" in the ProAgent editor on the \"Generation Run\" tab or have modified the settings for the system hardware or the key labeling prior to generation, the ProAgent initialization function \"ProAgentInit.pas\" will likewise be overwritten. Your changes are then undone.\u003c/span\u003e\u003c/div\u003e\u003c/div\u003e\u003c/td\u003e\u003c/tr\u003e\u003ctr\u003e\u003ctd colspan=\"3\" class=\"hint-lower-line\" /\u003e\u003c/tr\u003e\u003c/table\u003e\u003c/div\u003e\u003cdiv class=\"p p-default floating-text\" /\u003e\u003c/div\u003e\u003c/div\u003e\u003cdiv class=\"header-object block-title-top expandable-container\"\u003e\u003cdiv class=\"h4 block-title header-object\" data-expandable=\"minus\"\u003e\u003cspan class=\"data-expandable\"\u003eSee also\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"expandable-content\" style=\"display: block;\"\u003e\u003cdiv class=\"p floating-text\"\u003e\u003cspan class=\"seeAlso\"\u003e\u003ca data-type=\"hotspot-link\" id=\"hs_chk2bdfc79515e1031d72008ef82d0b5650\" class=\"hotspot-link display-i-none\" data-mode=\"\" data-label=\"\" data-linktarget=\"2bdfc79515e1031d72008ef82d0b5650\" data-targettype=\"\" data-targetdocument=\"d01c46065d2117906d3b5ae92a2264b4\" data-targetdetail=\"2bdfc79515e1031d72008ef82d0b5650\" onClick=\"\" href=\"#\" data-linktype=\"see-also\"\u003e\u003ci class=\"\" /\u003e\u003cspan\u003e\u003cspan\u003eCriteria Analysis\u003c/span\u003e\u003c/span\u003e​\u003c/a\u003e\u003c/span\u003e\u003c/div\u003e\u003cdiv class=\"p floating-text\"\u003e\u003cspan class=\"seeAlso\"\u003e\u003ca data-type=\"hotspot-link\" id=\"hs_chkde69f74217af54bcd438b370f468a013\" class=\"hotspot-link display-i-none\" data-mode=\"\" data-label=\"\" data-linktarget=\"de69f74217af54bcd438b370f468a013\" data-targettype=\"\" data-targetdocument=\"d01c46065d2117906d3b5ae92a2264b4\" data-targetdetail=\"de69f74217af54bcd438b370f468a013\" onClick=\"\" href=\"#\" data-linktype=\"see-also\"\u003e\u003ci class=\"\" /\u003e\u003cspan\u003e\u003cspan\u003eProAgent Functions (Overview)\u003c/span\u003e\u003c/span\u003e​\u003c/a\u003e\u003c/span\u003e\u003c/div\u003e\u003c/div\u003e\u003c/div\u003e\u003c/div\u003e\u003c/div\u003e\u003c/html\u003e"}